<template>
<div class="cab">
  <el-scrollbar>
  <!--header-->
  <our-header/>
  <!--中间内容-->
  <el-container class="container" >
  <el-main>
  <vue-particles
    color='#3498db'
    :particleOpacity='0.7'
    :particlesNumber='80'
    shapeType='circle'
    :particleSize='4'
    linesColor='#3498db'
    :linesWidth='1'
    :lineLinked='true'
    :lineOpacity='0.4'
    :linesDistance='150'
    :moveSpeed='4'
    :hoverEffect='true'
    hoverMode='grab'
    :clickEffect='true'
    clickMode='push'
  >
  </vue-particles>
  <!--炫酷走马灯-->
  <el-carousel :interval="3000" type="card" height="160px" ref="carousel" @click.native="linkTo">
    <el-carousel-item v-for="item in images" :key="item.index">
      <img :src="item.url" style="height: 160px; width: 270px;">
    </el-carousel-item>
  </el-carousel>
  <div> 
    <!--清除按钮-->
    <el-button type="info" icon="el-icon-delete" class="danger" style="position: relative;" @click="clearData">清除</el-button>
    <!--搜索按钮-->
    <el-button type="info" icon="el-icon-search" class="search_button" style="position: relative;" @click="getData">搜索</el-button>
  </div> 
  <!--表格-->
  <el-table
    ref="singleTable"
    :data="tableData.slice((currentPage-1)*pagesize,currentPage*pagesize)"
    highlight-current-row stripe border
    empty-text="没有找到符合条件的课程！"
    @row-dblclick="handleCurrentChange"
    class="table"
    :row-style="{height:'20px'}">
    <!--Table 组件提供了单选的支持，只需要配置highlight-current-row属性即可实现单选。之后由current-change事件来管理选中时触发的事件，它会传入currentRow，oldCurrentRow。如果需要显示索引，可以增加一列el-table-column，设置type属性为index即可显示从 1 开始的索引号。-->
    <el-table-column align="left" header-align="center" prop="_id" label="课程ID" margin: auto>
       <template slot="header" slot-scope="{}">
          <span class="el-dropdown-link">
            课程ID
          </span>
          <el-select v-model="value1" allow-create clearable multiple filterable placeholder="课程ID" class="myselect">
          <!--v-model的值为当前被选中的el-option的 value 属性值-->
            <el-option
              v-for="item in options1"
              :key="item.value"
              :value="item.value">
            </el-option>
          </el-select>
        
      </template>
      <template slot-scope="scope">{{scope.row._id}}</template>
    </el-table-column>

    <el-table-column align="left" header-align="center" prop="name" label="课程" margin: auto>
      <template slot="header" slot-scope="{}">
          <span class="el-dropdown-link">
            课程名称
          </span>
          <el-select v-model="value2" allow-create clearable multiple filterable placeholder="输入课程名称" class="myselect">
          <!--v-model的值为当前被选中的el-option的 value 属性值-->
            <el-option
              v-for="item in options2"
              :key="item.value"
              :value="item.value">
            </el-option>
          </el-select>
      </template>
      <template slot-scope="scope">{{scope.row.name}}</template>
    </el-table-column>

    <el-table-column align="left" header-align="center" prop="teacher" label="授课老师" margin: auto>
      <template slot="header" slot-scope="{}">
          <span class="el-dropdown-link">
            授课老师
          </span>
          <el-select v-model="value3" allow-create clearable multiple filterable placeholder="输入老师" class="myselect">
          <!--v-model的值为当前被选中的el-option的 value 属性值-->
            <el-option
              v-for="item in options3"
              :key="item.value"
              :value="item.value">
            </el-option>
          </el-select>
      </template>
      <template slot-scope="scope">{{scope.row.teacher}}</template>
    </el-table-column>

    <el-table-column align="left" header-align="center" prop="type" label="标签" margin: auto>
      <template slot="header" slot-scope="{}">
          <span class="el-dropdown-link">
            标签
          </span>
          <el-select v-model="value4" allow-create clearable multiple filterable placeholder="选择标签" class="myselect">
          <!--v-model的值为当前被选中的el-option的 value 属性值-->
            <el-option
              v-for="item in options4"
              :key="item.value"
              :value="item.value">
            </el-option>
          </el-select>
      </template>
      <template slot-scope="scope">{{scope.row.type}}</template>
    </el-table-column>

    <el-table-column align="left" header-align="center" prop="place" label="校区" margin: auto>
      <template slot="header" slot-scope="{}">
          <span class="el-dropdown-link">
            校区
          </span>
          <el-select v-model="value5" allow-create clearable multiple filterable placeholder="选择校区" class="myselect">
          <!--v-model的值为当前被选中的el-option的 value 属性值-->
            <el-option
              v-for="item in options5"
              :key="item.value"
              :value="item.value">
            </el-option>
          </el-select>
      </template>
      <template slot-scope="scope">{{scope.row.place}}</template>
    </el-table-column>

    <el-table-column align="left" header-align="center" prop="period" label="时间" margin: auto>
      <template slot="header" slot-scope="{}">
          <span class="el-dropdown-link">
            时间
          </span>

          <div class="block">
            <el-cascader
              v-model="value6"
              :options="options6"
              :props="{ multiple: true, checkStrictly: true }"
              clearable filterable placeholder="选择时间"></el-cascader>
          </div>
      </template>
      <template slot-scope="scope">{{weekDay[scope.row.day]}}:&nbsp{{beginTime[scope.row.period]}}-{{endTime[scope.row.period+scope.row.length-1]}}</template>
    </el-table-column>

  </el-table>
  <!--分页器-->
  <div class="pagination">
    <el-pagination
      @size-change="handleSizeChange"
      @current-change="handleCurrentpaginationChange"
      :current-page="currentPage"
      :page-size="pagesize"
      layout="prev, pager, next, jumper"
      :total="tableData.length"
      style="height: 2%; border: 1px solid #eee;position: relative;">
    </el-pagination>
  </div>
  </el-main>
  </el-container>
  </el-scrollbar>
</div>
</template>

<script>
import OurFooter from '@/components/common/OurFooter.vue';
import OurHeader from '@/components/common/OurHeader.vue';

export default {
  name: 'SearchView',
  data() {
    return {
      beginTime:['','8:00','8:50','10:00','10:50','13:30','14:20','15:30','16:20','19:00','19:50','20:40'],
      endTime:['','8:45','9:35','10:45','11:35','14:15','15:05','16:15','17:05','19:45','20:35','9:25'],
      weekDay:['','周一','周二','周三','周四','周五'],
      //多项选择器
      options1: [],
      value1: [],
      options2: [],
      value2: [],
      options3: [],
      value3: [],
      options4: [{
        value: '通识选修课'
      }, {
        value: '专业选修课'
      }, {
        value: '实践课'
      }, {
        value: '专业基础课'
      }, {
        value: '跨学科选修课'
      }],
      value4: [],
      options5: [{
        value: '嘉定校区'
      }, {
        value: '沪西校区'
      }, {
        value: '四平路校区'
      }, {
        value: '沪北校区'
      }, {
        value: '彰武校区'
      }],
      value5: [],
    
      options6:[{
        value: '1',
        label:'周一',
        children:[{
          value: '1',
          label: '8:00-9:35'
        }, {
          value: '3',
          label: '10:00-11:35'
        }, {
          value: '5',
          label: '13:30-15:05'
        }, {
          value: '7',
          label: '15:30-17:05'
        }, {
          value: '9',
          label: '19:00-20:35' 
        }]
      }, {
        value: '2',
        label:'周二',
        children:[{
          value: '1',
          label: '8:00-9:35'
        }, {
          value: '3',
          label: '10:00-11:35'
        }, {
          value: '5',
          label: '13:30-15:05'
        }, {
          value: '7',
          label: '15:30-17:05'
        }, {
          value: '9',
          label: '19:00-20:35' 
        }]
      }, {
        value: '3',
        label:'周三',
        children:[{
          value: '1',
          label: '8:00-9:35'
        }, {
          value: '3',
          label: '10:00-11:35'
        }, {
          value: '5',
          label: '13:30-15:05'
        }, {
          value: '7',
          label: '15:30-17:05'
        }, {
          value: '9',
          label: '19:00-20:35' 
        }]
      }, {
        value: '4',
        label:'周四',
        children:[{
          value: '1',
          label: '8:00-9:35'
        }, {
          value: '3',
          label: '10:00-11:35'
        }, {
          value: '5',
          label: '13:30-15:05'
        }, {
          value: '7',
          label: '15:30-17:05'
        }, {
          value: '9',
          label: '19:00-20:35' 
        }]
      }, {
        value: '5',
        label:'周五',
        children:[{
          value: '1',
          label: '8:00-9:35'
        }, {
          value: '3',
          label: '10:00-11:35'
        }, {
          value: '5',
          label: '13:30-15:05'
        }, {
          value: '7',
          label: '15:30-17:05'
        }, {
          value: '9',
          label: '19:00-20:35' 
        }]
      }],
      value6: [],
      currentPage: 1, //默认显示页面为1
      pagesize: 15, //    每页的数据条数
      tableData: [], //需要data定义一些，tableData定义一个空数组，请求的数据都是存放这里面
      //走马灯图片
      images:[{
        url:require('../assets/images/34001010.png'),
        link:'/courseInfo/34001010'
      },{
        url:require('../assets/images/34001011.png')
        ,link:'/courseInfo/34001011'
      },{
        url:require('../assets/images/34001012.png'),
        link:'/courseInfo/34001012'
      }],
      logo_src:require('../img/logo.png'),
      person_src:require('../img/person_src.jpg'),
      isCollapse: true,
      screenWidth: window.innerWidth,
      screenHeight: window.innerHeight,
    };
  },
  mounted() {
    this.getData();
    window.addEventListener('resize', () => {
      this.screenWidth = window.innerWidth;
      this.screenHeight = window.innerHeight;
      if(this.screenWidth<200)
      {
        this.pagesize=1;
      }
      if(this.screenWidth<300)
      {
        this.pagesize=2;
      }
      if(this.screenWidth<400)
      {
        this.pagesize=3;
      }
      if(this.screenWidth<500)
      {
        this.pagesize=3;
      }
      if(this.screenWidth<600)
      {
        this.pagesize=4;
      }
      if(this.screenWidth<700)
      {
        this.pagesize=5;
      }
      if(this.screenWidth<800)
      {
        this.pagesize=6;
      }
      if(this.screenWidth<900)
      {
        this.pagesize=7;
      }
      if(this.screenWidth<1000)
      {
        this.pagesize=8;
      }
      if(this.screenWidth<1100)
      {
        this.pagesize=9;
      }
      if(this.screenWidth<1200)
      {
        this.pagesize=10;
      }
      if(this.screenWidth<1300)
      {
        this.pagesize=11;
      }
      else if(this.screenWidth<1400)
      {
        this.pagesize=12;
      }
      if(this.screenWidth<1500)
      {
        this.pagesize=13;
      }
      if(this.screenWidth<1600)
      {
        this.pagesize=14;
      }
      else if(this.screenWidth<1800) this.pagesize=15;
      else this.pagesize=18;
      this.getData();
    });
  },
  methods: {
    linkTo() {
      let active_index = this.$refs.carousel.activeIndex;
      window.open(this.images[active_index].link, '_blank');
    },
    clearData(){
      this.value1=[];
      this.value2=[];
      this.value3=[];
      this.value4=[];
      this.value5=[];
      this.value6=[];
      this.getData();
    },
    getData() {
      var url = '/api/courses/get-courses';
      // 发送请求:将数据返回到一个回到函数中
      // 并且响应成功以后会执行then方法中的回调函数
      this.currentPage=1;
      // console.log(this.value6);
      this.$axios.get(url,
        {
          params:{
            _id:this.value1,
            name:this.value2,
            teacher:this.value3,
            type:this.value4,
            place:this.value5,
            day_period:this.value6

          }

        }).then(response => {
        this.tableData = response.data.courses;

      }, response => {
      });
    },
    //每页下拉显示数据
    handleSizeChange: function(size) {
      this.pagesize = size;
    },
    //点击第几页
    handleCurrentpaginationChange: function(currentPage) {
      this.currentPage = currentPage;
    },
    handleCurrentChange(row){
      this.$confirm('<strong>课程ID</strong>:'+row._id+'<br/>'+
        '<strong>课程名称</strong>:'+row.name+'<br/>'+
        '<strong>授课老师ID</strong>:'+row.tid+'<br/>'+
        '<strong>授课老师</strong>:'+row.teacher+'<br/>'+
        '<strong>标签</strong>:'+row.type+'<br/>'+
        '<strong>校区</strong>:'+row.place+'<br/>'+
        '<strong>语言</strong>:'+row.language+'<br/>'+
        '<strong>学院</strong>:'+row.department+'<br/>'+
        '<strong>时间</strong>:'+this.weekDay[row.day]+this.beginTime[row.period]+'-'+this.endTime[row.period+row.length-1]+'<br/>'+
        '<strong>地点</strong>:'+row.room, '信息', {
        distinguishCancelAndClose: true,
        dangerouslyUseHTMLString: true,
        confirmButtonText: '收藏',
        cancelButtonText: '详情',
        type: 'info',
        //center: true
        roundButton: true
      }).then(() => {
        var url = '/api/user/collections';
        var email = this.$store.getters.getEmail;
        this.$axios.post(url,
          {
            email: email,
            cid:row._id

          }).then(response => {
          // console.log('succed');
        }, response => {
          // console.log('error');
        });
        this.$message({
          type: 'success',
          message: '收藏成功!'
        });
      })
        .catch(action => {
          if(action === 'cancel') {
            window.open('/courseInfo/' + row._id, '_blank');
          }
        });
    },
  },
  components: {
    OurFooter,
    OurHeader
  },
};
</script>

<style scoped>


::-webkit-scrollbar {
  width: 0 !important;
}
::-webkit-scrollbar {
  width: 0 !important;height: 0;
}

.container
{
  height:100%; 
  min-height:800px;
  border: 1px solid #eee;
}


.aside
{
  width:210px !important;
  background-color: rgb(244, 244, 245); 
  border-right:1px solid #ddd
}

.sub_menu
{
  background-color: #d3dce6;
}

.search_button
{
  color:#333 !important;
  background:rgb(198, 226, 255) !important;
  border:0 !important;
}

.table
{
  width: 80% !important;
  height:75%;
  min-height:820px;
  margin-left:10%;
  margin-top:1%;
  margin-bottom:1%;
  font-size: 16px;
  font-family:Helvetica Neue;
  position: relative;
}

::v-deep.myselect>.el-input 
{
  width: 100%;
  display: block;
}

#particles-js
{
  width: 100%;
  height: 100%;
  position: absolute;
}

::-webkit-scrollbar {
  width: 0 !important;
}
::-webkit-scrollbar {
  width: 0 !important;height: 0;
}

.el-table,
		.el-table__expanded-cell 
    {
			background-color: transparent !important;
		}
		/* 表格内背景颜色 */
		.el-table th,
		.el-table tr,
		.el-table td 
    {
			background-color: transparent !important;
		}
		
		/* 删除表格下横线 */
		.table-wrapper  .el-table::before 
    {
			left: 0;
			bottom: 0;
			width: 100%;
			height: 0px;
		}
		.table-wrapper  .el-table td .cell 
    {
			color: #fff !important;
		}
		.table-wrapper  .el-table th .cell 
    {
			color: #fff !important;
		}
		/* 删除单元格底部横线 */
		.table-wrapper  .el-table td 
    {
			border-bottom: 0px solid #dfe6ec !important;
		}
		.table-wrapper  .el-table th 
    {
			border-bottom: 0px solid #dfe6ec !important;
		}
</style>
